#!/usr/local/bin/perl

# Access Panda v1.1 
# Copyright (C) 1996  Big Panda House.  All Rights Reserved.
# This software is distributable under the terms of the 
# license agreement at this URL: 
# http://www.bigpanda.com/accesspanda/license.html
# you must read and agree to this document before using Access Panda.

#          *** PLEASE MODIFY THE FOLLOWING CODE ***

$hide_these_urls = '\.cgi|\.gif|\.jpg|\.class|\.zip|\.gz|\.java|\.txt';

# $hide_these_urls
#   Do not include pages whose URLs match this regular expression.
#   For help on regular expressions, please consult your Perl 
#   documentation. This is used primarily to discount GIF and other 
#   files which are not really pages.

$show_these_urls = 'accesspanda/accesspanda\.tar\.gz';

# $show_these_urls
#   Even if a page matches the regular expression $hide_these_urls,
#   show it if it matches the regular expression $show_these_urls.

$log_file_path   = '/share/apache-logs/';

# $log_file_path
#   This is where Access Panda looks for log files. You should make
#   sure that there is a slash at the end of $log_file_path.

$show_x_machines = 10;

# $show_x_machines
#   When listing the machines which have accessed the most pages,
#   list no more than this many machines. 

$show_x_pages    = 10;

# $show_x_pages
#   When listing the pages which have been accessed the most,
#   list no more than this many pages. 

$show_x_domains  = 10;

# $show_x_domains
#   When listing the domains which have accessed the most pages,
#   list no more than this many domains. 

$default_time = 'yesterday';

# $default_time
#   If the user does not specify a time range, use this one.

$top_level_domain_file = 'toplevel.txt';

# $top_level_domain_file
#   This file contains human-readable equivalents for many
#   top-level domains.

# ********** DO NOT MODIFY THE FOLLOWING CODE *************

$version_major = 1;
$version_minor = 1;

use CGI;
use Date::Manip;

sub postlink {
  my $name = shift;
  print "<form method=get action=\"" . $query->self_url() . "\">";
  for( $query->param() ) {
    print "<input type=hidden name=\"$_\" value=\"" . $query->param($_) . "\">";
  }
  print "<input type=submit value=\"$name\"></form>";
}

sub printheader {
print <<HEADER;
<html>
<head><title>Access Panda v$version_major.$version_minor</title></head>
<body bgcolor=#ffffff>

<table width=100%><tr valign=top>
<td><img align=left src="access.gif"></td>
<td><center><font size=5>$domain</font></center></td>
</tr></table>
HEADER
}

sub printfooter {
print <<FOOTER;
<br>
<table width=100%><tr>
<td>
This report was generated by <a href="http://www.bigpanda.com/accesspanda/v$version_major$version_minor/">Access Panda v$version_major.$version_minor</a>.<br>
Copyright &copy;1996 <a href="http://www.bigpanda.com/">Big Panda House</a>. All Rights Reserved.
</td><td>
<img align=right src="panda.gif">
</td>
</tr></table>

</body>
</html>
FOOTER
}

sub entryform {
print <<ENTRYFORM;

<h1>O P T I O N S</h1>

<form method=get action="$url">

<input size=40 name=accessfile value="$accessfile"> Log File<br>
<input size=40 name=target     value="$target"    > Date / Range of Dates<br>

<br>

Show top <input size=3 maxlength=3 name=mabp  value=$mabp > pages<br>
Show top <input size=3 maxlength=3 name=mabm  value=$mabm > machines<br>
Show top <input size=3 maxlength=3 name=mabtl value=$mabtl> top-level domains<br>

<br>

<table width=100%><tr valign=top>
<td>
<input type=checkbox name=sh   value="CHECKED" @{[$query->param('sh')]}  > Don't show hits<br>
<input type=checkbox name=se   value="CHECKED" @{[$query->param('se')]}  > Show errors<br>
<input type=checkbox name=stp  value="CHECKED" @{[$query->param('stp')]} > Don't show hits by page<br>
<input type=checkbox name=stm  value="CHECKED" @{[$query->param('stm')]} > Don't show hits by machine<br>
<input type=checkbox name=stt  value="CHECKED" @{[$query->param('stt')]} > Don't show hits by top-level domain<br>
<input type=checkbox name=shd  value="CHECKED" @{[$query->param('shd')]} > Don't show hits by hour of day<br>
</td><td>
<input type=checkbox name=shw  value="CHECKED" @{[$query->param('shw')]} > Don't show hits by day of week<br>
<input type=checkbox name=shdm value="CHECKED" @{[$query->param('shdm')]}> Don't show hits by day of month<br>
<input type=checkbox name=shm  value="CHECKED" @{[$query->param('shm')]} > Don't show hits by month<br>
<input type=checkbox name=nl   value="CHECKED" @{[$query->param('nl')]}  > Do name lookups on internet addresses (very slow!)<br>
<input type=checkbox name=tl   value="CHECKED" @{[$query->param('tl')]}  > Don't display pretty top-level domain names<br>
<input type=submit value="GO!">
</td>
</tr></table>

</form>

ENTRYFORM
  printfooter();
  exit(0);
}


sub printlist {
 my @list=@_;
 my $maxnum=$list[0];
 my $fullnum=$list[1];
 my $hashref=$list[2];
 my %hashref=%$hashref;
 my $count;
 shift @list;
 shift @list;
 shift @list;

 if ($#list==-1 || $fullnum==0) {
  return;
 }
 my @retlist;
 if ($maxnum<0) {
  $count=$#list;
 } 
 else {
  $count = $maxnum-1;
  if ($count>$#list) {
   $count=$#list;
  }
 }

 print <<PRINTLISTHEADER;

<tr bgcolor=#ccfecc align=center>
<td><font size=1>ITEM</font></td>
<td><font size=1>PERCENTAGE</font></td>
<td><font size=1>POPULARITY</font></td>
<td><font size=1>HITS</font></td>
</tr>

PRINTLISTHEADER

 $max = $hashref{$list[0]};
 foreach $foo (@list[1..$count]) {
     if( $max < $hashref{$foo} ) {
	 $max = $hashref{$foo};
     }
 }
 foreach $foo (@list[0..$count]) {

  $displayfoo=$foo;
  $displayfoo=~ s/(.{25})(.{6,})(.{10})/$1 ... $3/;

  use integer;
  $perc = $hashref{$foo} * 10000 + 5;
  $perc /= $fullnum;
  $perc /= 10;
  no integer;
  $perc /=10;

  use integer;
  $pixels = $hashref{$foo} * 200;
  $pixels /= $max;
  no integer;
  $pixels -=8;
  if( $pixels < 2 ) { $pixels=2; }

	print <<PRINTLISTBODY;

<tr>
<td align=center>$displayfoo</td>
<td align=center>$perc\%</td>
<td><img width=4 height=10 src=gl.gif><img width=$pixels height=10 src=gv.gif><img width=4 height=10 src=gr.gif></td>
<td align=center>$hashref{$foo}</td>
</tr>

PRINTLISTBODY

    }

    print <<PRINTLISTFOOTER;

<tr bgcolor=#ccfecc align=center>
<td><font size=1>ITEM</font></td>
<td><font size=1>PERCENTAGE</font></td>

PRINTLISTFOOTER

    print "<td bgcolor=#ffffff align=left>";
    print "<img src=gl.gif width=4 height=10><img src=gv.gif width=12 height=10><img src=gr.gif width=4 height=10>" x 10;
    print "<td><font size=1>HITS</font></td>\n</tr>";
}

sub getlist {
 my @list=@_;
 my $totnum=$list[0];
 my $hashref=$list[1];
 my %hashref=%$hashref;
 shift @list;
 shift @list;
 my @retlist;

 if ($#list==-1 || $fullnum==0) {
  return;
 }

 foreach $foo (@list) {
  use integer;
  $perc=($hashref{$foo}*100000+5)/($totnum)/10;
  no integer;
  $perc/=100;
  @retlist=(@retlist, [$foo, $hashref{$foo}, $perc]);
 }
 return @retlist;
}

sub nametotoplevel {
    my $name = $_[0];
    if ($name =~ /\d+\.\d+\.\d+\.\d+/) {
	return "unknown";
    }
    else {
	my $toplvl;
        @l = split /\./, $name;
        if ($#l>-1) {
 	 $toplvl=$l[$#l];
         } 
         else {
	  $toplvl=$name;
         }
        return lc($toplvl);
    }
}

sub numtoname {
    local($_) = @_;
    unless (defined $numtoname{$_}) {
#        local(@a) = gethostbyaddr(pack('C4',split(/\./)),2);
#        $numtoname{$_} = @a > 0 ? $a[0] : $_;
	my $tmp=`nslookup -timeout=2 -retry=1 $_`;
        ($name) = ($tmp =~ /Name\:\s*(.*)\n/i);
        if (defined($name)) {
         $numtoname{$_}=$name;
        } else {
         $numtoname{$_}=$_;
        } 
    }
    return($numtoname{$_});
}

sub parsedates {
 my $datetype=@_[0];
 my $l;
 my $h;
 if ($datetype =~ /^yesterday$/i) {
  $l=&DateCalc("today", "-1 day");
  $h=&DateCalc("today", "-1 day");
  #These are done because $l=&Date_SetTime($h, 0, 0, 0) didn't seem to work!
  $l =~ s/\d\d\:\d\d\:\d\d$/00:00:00/;
  $h=&Date_SetTime($h, 23, 59, 59);
 }
 elsif ($datetype =~ /^this\s*month$/i) {
  $l=&ParseDate("today");
  $l=~s/(\d\d\d\d\d\d)\d\d\d\d\:\d\d\:\d\d$/${1}0100:00:00/;
  $h=&ParseDate("today");
  $h=&Date_SetTime($h, 23, 59, 59);
 }
 elsif ($datetype =~ /^last\s*month$/i) {
  $l=&DateCalc("today", "-1 month");
  $l=~s/(\d\d\d\d\d\d)\d\d\d\d\:\d\d\:\d\d$/${1}0100:00:00/;
  $h=&DateCalc($l, "+1 month -1 day");
  $h=&Date_SetTime($h, 23, 59, 59);
 }
 elsif ($datetype =~ /^this\s*week$/i) {
  $l=&Date_GetPrev(&ParseDate("today"),"Sun",1,"00:00:00");
  $h=&Date_GetNext(&ParseDate("today"),"Sat",1,"23:59:59");
 }
 elsif ($datetype =~ /^last\s*week$/i) {
  $l=&Date_GetPrev(&DateCalc("today","-7 days"),"Sun",1,"00:00:00");
  $h=&Date_GetNext(&DateCalc("today","-7 days"),"Sat",1,"23:59:59");
 }
 elsif ($datetype =~ /^today$/i) {
  $l=&ParseDate("today");
  $h=&ParseDate("today");
  $l =~ s/\d\d\:\d\d\:\d\d$/00:00:00/;
  $h=&Date_SetTime($h, 23, 59, 59);
 }
 elsif ($datetype =~ /all/i) {
  $l=$first;
#  $l="1900010100:00:00";
  $h=&ParseDate("today");
  $h=&Date_SetTime($h, 23, 59, 59);
 }
 elsif ($datetype =~ /year\s*of/i) {
  my $garbage;
  my $date;
  ($date) = ($datetype =~ /year\s*of\s*(.*)/);
  $l=$date."010100:00:00";
  $h=$date."123123:59:59";
 }
 elsif ($datetype =~ /month\s*of/i) { 
  my $garbage;
  my $date;
  ($date) = ($datetype =~ /month\s*of\s*(.*)/);  
  $l=&ParseDate($date);
  $l=~s/(\d\d\d\d\d\d)\d\d\d\d\:\d\d\:\d\d$/${1}0100:00:00/;  
  $h=&DateCalc($l, "+1 month -1 day");
  $h=&Date_SetTime($h, 23, 59, 59);
 }
 elsif ($datetype =~ /week\s*(of|including)/i) {
  my $garbage;
  my $date;
  ($garbage, $date) = ($datetype =~ /week\s*(of|including)\s*(.*)/);
  $l=&Date_GetPrev(&ParseDate("$date"),"Sun",1,"00:00:00");
  $h=&Date_GetNext(&ParseDate("$date"),"Sat",1,"23:59:59");
 }
 elsif ($datetype =~ /(before|after)/) {
  #[n days] after date
  #[n days] before date
  my $first;
  my $oper;
  my $date;

  ($first, $oper, $date) = ($datetype =~ /(.*)\s*(before|after)\s*(.*)/i);
  if ($first =~ /^\s*$/) {
   if ($oper =~ /before/) {
    $h=&ParseDate($date);
    $h=&DateCalc($h, "-1 day");
    $h=&Date_SetTime($h, 23,59,59);
#    $l="1900010100:00:00";
    $l=$first;
   }
   else {
    $l=&ParseDate($date);
    $l=&DateCalc($l,"+1 day");
    $h=&ParseDate("today");
    $h=&Date_SetTime($h, 23,59,59);
   }
  } 
  else {
   if ($oper =~ /before/) {
    $h=&ParseDate($date);
    $l=&DateCalc($h, "-$first");
    $h=&DateCalc($date, "-1 day");
    $h=&Date_SetTime($h, 23,59,59);
   }
   else {
    $l=&ParseDate($date,"");
    $h=&DateCalc($l, "+$first");
    $l=&DateCalc($date,"+1 day");
    $h=&Date_SetTime($h, 23,59,59);
   }
  }  
 }
 else {
    $l=$h=&ParseDate($datetype);
    $h=&Date_SetTime($h, 23,59,59);
 }
 return ($l, $h);
}

$query=new CGI;

@temp = $query->param();
for( @temp ) {
  if( ! ($query->param($_) =~ /\w/) ) {
    $query->delete($_);
  }
}

print $query->header;

$domain=$ENV{'SERVER_NAME'};
$domain=~ s/^www.//;

printheader();

$url = $query->url();

$urlallow  = $query->param('urlallow')  || $show_these_urls;
$urlexcept = $query->param('urlexcept') || $hide_these_urls;

$accessfile = $query->param('accessfile') || "$log_file_path$domain-access_log";

$nl = $query->param('nl');

$mfbm  = $mabm  = $query->param('mabm'  ) || $query->param('mabm'  , $show_x_machines);
$mfbp  = $mabp  = $query->param('mabp'  ) || $query->param('mabp'  , $show_x_pages   );
$mfbtl = $mabtl = $query->param('mabtl' ) || $query->param('mabtl' , $show_x_domains );

$target = $query->param('target') || $default_time;

if( $query->param('options') ) {
  entryform();
}

if (!(-r $accessfile)) {
#    print $query->header;
#    print $query->start_html;
    print <<NOTICE;

<P>Access Panda can not find the log file for $domain. 
Please enter its path now. If you would like Access Panda 
to remember this path, you may have to edit the Perl 
script "AccessPanda.cgi".</p>

NOTICE
    print $query->startform("get", $ENV{'SCRIPT_NAME'});
    print $query->textfield(-name=>"accessfile", -default=>"$log_file_path$domain-access_log",
			    -size=>80, -maxlength=>200);
    foreach $p ($query->param()) {
        if ($p ne "accessfile") {
	     print $query->hidden(-name=>$p, -default=>$query->param($p));
        }
    }
    print " &nbsp; ", $query->submit('Ok');
    print $query->endform;
    print $query->end_html;
    exit(0);
}

open(READER, "$accessfile");
$foo=<READER>;
($first) = ($foo =~ /[^\s]* [^\s]* [^\s]* \[([^\:]*)\:/);
if (defined($first)) {
    $first=&ParseDate($first);
    if (!$first) {
	$first=&ParseDate("today");
    }
} else {
    $first=&ParseDate("today");
}
$first=~ s/\d\d\:\d\d\:\d\d$/00:00:00/;
close(READER);

($l, $h) = parsedates($target);
if ($l =~ /^\s*$/ || $h =~ /^\s*$/) {
    print "<H3> Invalid (or Empty) Target Date String Given.</H3>";
    printfooter();
    exit(0);
}

$totacc=0;
$totfai=0;
%page=();
%pagebm=({});
%rawtoplevel=();
%machine=();
@day=(0)x31;
@month=(0)x12;
@hour=(0)x24;
@dayweek=(0)x7;

%failedbp=();
%failedbm=();
%rawfailedbtl=();
%dates=();

%cache_page=({});
%cache_machine=({});
%cache_failpage=({});
%cache_failmachine=({});
%cache_hour=();

%incache=();
$allcached=1;

$outallow=$urlallow;
$outallow =~ s/([^\d\w])/"%".ord($1)/eg;
$outexcept=$urlexcept;
$outexcept =~ s/([^\d\w])/"%".ord($1)/eg;

#for every day in the realm
$tmpdate=$l;
while (!($tmpdate gt $h)) {
  $outdate=$tmpdate;
  $outdate =~ s/\d\d\:\d\d\:\d\d$//;
  $count=0;
  if (-e "cache/$outdate.$outallow.$outexcept") {
       ($month, $day) = ($tmpdate =~ /^\d\d\d\d(\d\d)(\d\d)/);
       $month=$month-1;
       $day=$day-1;
       $dayweek=&UnixDate($tmpdate, "%w");
       open(READER, "<cache/$outdate.$outallow.$outexcept") ;
       for ($i=0; $i<24; $i++) {
        $hour[$i]+=<READER>;
       }
       $number=<READER>;
       for ($i=0; $i<=$number; $i++) {
	   $_=<READER>;
        ($url, $num) = /(.*)\s+(\d+)$/;
        $url =~ s/\?.*$//;
        $page{$url}+=$num;
	   $month[$month]+=$num;
	   $day[$day]+=$num;
	   $dayweek[$dayweek]+=$num;
	$totacc+=$num;
       } 
       $number=<READER>;
       for ($i=0; $i<=$number; $i++) {
	   $_=<READER>;
        ($machine, $num) = /(.*)\s+(\d+)$/;
        if ($nl eq 'CHECKED' && $machine =~ /\d+\.\d+\.\d+\.\d+$/) {
         $machine=numtoname($machine);
        }
	$toplevel=nametotoplevel($machine);
        $machine{$machine}+=$num;
	$rawtoplevel{$toplevel}+=$num;
       }       
       $number=<READER>;
       for ($i=0; $i<=$number; $i++) {
	   $_=<READER>;
        ($url, $num) = /(.*)\s+(\d+)$/;
        $url =~ s/\?.*$//;
        $failedbp{$url}+=$num;
	   $totfai+=$num;
       }
       $number=<READER>;
       for ($i=0; $i<=$number; $i++) {
	   $_=<READER>;
	   ($machine, $num) = /(.*)\s+(\d+)$/;
        if ($nl eq 'CHECKED' && $machine =~ /\d+\.\d+\.\d+\.\d+$/) {
         $machine=numtoname($machine);
        }
	$toplevel=nametotoplevel($machine);
        $failedbm{$machine}+=$num;
	$rawfailedbtl{$toplevel}+=$num;
       }
       $incache{$tmpdate}=1;     
       close(READER);
  }
  if (!$incache{$tmpdate}) {
       $allcached=0;
  }
  $tmpdate=&DateCalc($tmpdate, "+1 day");
}

$today=&ParseDate("today");
$today=~ s/\d\d\:\d\d\:\d\d$/00:00:00/;

$stad=&UnixDate($l, "%b %d, %Y");
$endd=&UnixDate($h, "%b %d, %Y");

if (!$allcached) {
#open(READER, "/usr/local/httpd/logs/bigpanda.com-access_log");
open(READER, $accessfile);
while(<READER>) {
 ($machine, $date, $time, $tzone, $method, $url, $httpvers, $response, $size) =   /([^\s]*) [^\s]* [^\s]* \[([^\:]*):([^\s]*) ([^\]]*)\] \"([^\s]*) ([^\s]*) HTTP\/([^\"]*)\" (\d*) (\d*)/;

 #the date values are cached for speed, since in general the same date will show up many times
 if (defined $dates{$date}) {
  $d=$dates{$date};
 } else {
  $dates{$date}=$d=&ParseDate($date);
 }

 if (!($d lt $l || $d gt $h) && !$incache{$d}) {
  if ($url =~ /$urlallow/i || $url !~ /$urlexcept/i) {
      ($hour) = ($time =~ /^(\d\d)/);
      ($month,$day) = ($d =~ /^\d\d\d\d(\d\d)(\d\d)/);
      $month=$month-1; #we want 0-based array index months, not 1 based
      $day=$day-1; #we want 0-based array index day not 1 based
   if ( ($nl eq 'CHECKED') && $machine=~/^\d+\.\d+\.\d+\.\d+/) {
    $machine=numtoname($machine);
   }
   $url =~ s/\?.*//;
   $toplevel=nametotoplevel($machine);
   if ($response eq "200") {
    $machine{$machine}++;
    $rawtoplevel{$toplevel}++;
    $page{$url}++;
    $pagebm{$machine}{$url}++;
    $dayweek[&UnixDate($d, "%w")]++;
    $day[$day]++;
    $month[$month]++;
    $hour[$hour]++;

    $cache_machine{$d}{$machine}++;
    $cache_page{$d}{$url}++;
#    $cache_pagebm{$d}{$machine}{$url}++;
    if (!defined($cache_hour{$d})) {
	$cache_hour{$d}=[0]x24;
    }
    $cache_hour{$d}[$hour]++;

    $docache{$d}=1;

    $totacc++;
   }
#   elsif ($response eq "404") {
   elsif ($response ne "304") {
    $failedbp{$url}++;
    $rawfailedbtl{$toplevel}++;
    $failedbm{$machine}++;

    $cache_failmachine{$d}{$machine}++;
    $cache_failpage{$d}{$url}++;
    $docache{$d}=1;

    $totfai++;
   }
  }
 }
}
close(READER);

foreach $cday (keys %docache) {
    if ($cday lt $today) {
        $outdate=$cday;
        $outdate =~ s/\d\d\:\d\d\:\d\d//;

	if (!(-e "cache/$outdate.$outallow.$outexcept")) {
            open(WRITER,">cache/$outdate.$outallow.$outexcept");
            $tmp=$cache_hour{$cday};
            @tmp=@$tmp;
       	    for ($i=0; $i<24; $i++) {
		print WRITER "$tmp[$i]\n";
       	    }
            $tmp=$cache_page{$cday};
            %tmp=%$tmp;
            @list=keys %tmp;
            print WRITER $#list."\n";
	    foreach $page (keys %tmp) {
		print WRITER "$page $tmp{$page}\n";
	    }
	    $tmp=$cache_machine{$cday};
	    %tmp=%$tmp;
            @list = keys %tmp;
            print WRITER $#list."\n";
	    foreach $machine (keys %tmp) {
		print WRITER "$machine $tmp{$machine}\n";
	    }
	    $tmp=$cache_failpage{$cday};
	    %tmp=%$tmp;
            @list=keys %tmp;
            print WRITER $#list."\n";
	    foreach $page (keys %tmp) {
		print WRITER "$page $tmp{$page}\n";
	    }
	    $tmp=$cache_failmachine{$cday};
	    %tmp=%$tmp;
            @list = keys %tmp;
            print WRITER $#list."\n";
	    foreach $machine (keys %tmp) {
		print WRITER "$machine $tmp{$machine}\n";
	    }
	    close(WRITER);
	}
    }
}
}

@sortedpage=sort {$page{$b} <=> $page{$a}} keys %page;
@sortedmachine=sort {$machine{$b} <=> $machine{$a}} keys %machine;
@sortedfailedbp=sort {$failedbp{$b} <=> $failedbp{$a}} keys %failedbp;
@sortedfailedbm=sort {$failedbm{$b} <=> $failedbm{$a}} keys %failedbm;

%lookup=();
open(READER, $top_level_domain_file );
while (<READER>) {
    ($a, $b) = ($_ =~  /(.*?)\s+(.*)/);
    $lookup{lc($a)}=$b;
}
close(READER);


sub dolookup {
    my $key=lc($_[0]);
    my $hashref=$_[1];
    my %hash=%$hashref;
    if (defined($hash{$key})) {
	return $hash{$key};
    } 
    else {
	return $key;
    }
}

%toplevel=();
%failedbtl=();

if( !$query->param('tl') ) {
  foreach $top (keys %rawtoplevel) {
      $toplevel{dolookup($top,\%lookup)}+=$rawtoplevel{$top};
  }
  foreach $top (keys %rawfailedbtl) {
      $failedbtl{dolookup($top,\%lookup)}+=$rawfailedbtl{$top};
  }
} else {
  foreach $top (keys %rawtoplevel) {
      $toplevel{$top}+=$rawtoplevel{$top};
  }
  foreach $top (keys %rawfailedbtl) {
      $failedbtl{$top}+=$rawfailedbtl{$top};
  }
}

@sortedtoplevel = sort {$toplevel{$b}<=>$toplevel{$a}} keys %toplevel;
@sortedfailedbtl = sort {$failedbtl{$b}<=>$failedbtl{$a}} keys %failedbtl;

#Variables:

# %page - by page information on hits
# @sortedpage - keys of %page sorted by number of hits

# %machine - by machine information on hits
# @sortedmachine - keys of %machine sorted by number of hits

# %failedbp - failed on page information on hits
# @sortedfailedbp - keys of %failedbp sorted by number of occurances

# %failedbm - failed by machine information on hits
# @sortedfailedbm - keys of %failedbm sorted by number of occurances

# %toplevel - by top level domain information on hits
# @sortedtoplevel - keys of %toplevel sorted by number of hits

# %failedbtl - failed by top level information
# @sortedfailedbtl - keys of %failedbtl sorted by number of occurances

# @day - hits by day of month
# @month - hits by month of year
# @hour - hits by hour of day
# @dayweek - hits by day of week

# %pagebm - a hash of hashes by machine and then page.

$nummachine=$#sortedmachine+1;
$numfailedmachine=$#sortedfailedbm+1;

#if( $stad ) {
#  if( $stad eq $endd ) {
#    print(" on $stad");
#  } else {
#    print(" from $stad");
#    if( $endd ) {
#      print(" to $endd");  
#    }
#  }
#} else {
#  if( $endd ) {
#    print(" by $endd");
#  }  
#}
#print( ".<br>\n" );

if ( !$query->param('sh') ) {

print "$nummachine machine";
if( $nummachine > 1 ) { print "s"; }
print " hit a total of $totacc page";
if( $totacc > 1 ) { print "s"; }
print( " $target.<br>\n" );

  if ( !$query->param('stp') ) {
    print <<PAGEHEADER;
<br><br>
<table>
<tr bgcolor=#ccfecc align=center> 
<td colspan=4><font size=1>H &nbsp; I &nbsp; T &nbsp; S &nbsp; &nbsp; &nbsp; B &nbsp; Y &nbsp; &nbsp; &nbsp; P &nbsp; A &nbsp; G &nbsp; E</font></td>
</tr>
PAGEHEADER

    printlist($mabp, $totacc, \%page, @sortedpage);
    print "</tr></table>\n";
  }
  if( !$query->param('stm') ) {
    print <<MACHINEHEADER;
<br><br>
<table>
<tr bgcolor=#ccfecc align=center> 
<td colspan=4><font size=1>H &nbsp; I &nbsp; T &nbsp; S &nbsp; &nbsp; &nbsp; B &nbsp; Y &nbsp; &nbsp; &nbsp; M &nbsp; A &nbsp; C &nbsp; H &nbsp; I &nbsp; N &nbsp; E</font></td>
</tr>
MACHINEHEADER

   printlist($mabm, $totacc, \%machine, @sortedmachine);

   print "</tr></table>\n";
  }
  if( !$query->param('stt') ) {
    print <<TOPHEADER;
<br><br>
<table>
<tr bgcolor=#ccfecc align=center>
<td colspan=4><font size=1>H &nbsp; I &nbsp; T &nbsp; S &nbsp; &nbsp; &nbsp; B &nbsp; Y &nbsp; &nbsp; &nbsp; T &nbsp; O &nbsp; P &nbsp; - &nbsp; L &nbsp; E &nbsp; V &nbsp; E &nbsp; L &nbsp; &nbsp; &nbsp; D &nbsp; O &nbsp; M &nbsp; A &nbsp; I &nbsp; N</fon

t></td>
</tr>
TOPHEADER

    printlist($mabtl, $totacc, \%toplevel, @sortedtoplevel);
    print "</tr></table>\n";
  }
  if ( !$query->param('shd') ) {
    print <<HOURLYHEADER;

<br><br>
<table width=70%>
<tr bgcolor=#ccfecc align=center>
<td colspan=24><font size=1>H &nbsp; O &nbsp; U &nbsp; R &nbsp; &nbsp; &nbsp; O &nbsp; F &nbsp; &nbsp; &nbsp; T &nbsp; H &nbsp; E &nbsp; &nbsp; &nbsp; D &nbsp; A &nbsp; Y</font></td>
</tr>
<tr valign=bottom>

HOURLYHEADER

    $max = $hour[0];
    for( $i=1; $i<24; $i++ ) {
	if( $max < $hour[$i] ) { $max = $hour[$i]; }
    }

    for ($i=0; $i<24; $i++) {
        use integer;

	$pct = $hour[$i] * 100;

	if ($max>0) {
          $pct /= $max;
        } 

        $pct -= 8;
        if( $pct < 2 ) { $pct = 2; }

	print <<HOURLYBODY;

<td align=center><img width=10 height=4 src=gt.gif><br><img width=10 height=$pct src=gh.gif><br><img width=10 height=4 src=gb.gif></td>

HOURLYBODY

	no integer;
    }

    print "<td align=center>";
    print "<img width=10 height=4 src=gt.gif><br><img width=10 height=2 src=gh.gif><br><img width=10 height=4 src=gb.gif><br>" x 10;

    print <<HOURLYFOOTER;

</td>
</tr>
<tr bgcolor=#ccfecc align=center>
<td><font size=1>12</font></td><td><font size=1>1</font></td><td><font size=1>2</font></td><td><font size=1>3</font></td>
<td><font size=1>4</font></td><td><font size=1>5</font></td><td><font size=1>6</font></td><td><font size=1>7</font></td>
<td><font size=1>8</font></td><td><font size=1>9</font></td><td><font size=1>10</font></td><td><font size=1>11</font></td>
<td><font size=1>12</font></td><td><font size=1>1</font></td><td><font size=1>2</font></td><td><font size=1>3</font></td>
<td><font size=1>4</font></td><td><font size=1>5</font></td><td><font size=1>6</font></td><td><font size=1>7</font></td>
<td><font size=1>8</font></td><td><font size=1>9</font></td><td><font size=1>10</font></td><td><font size=1>11</font></td>
</tr><tr bgcolor=#ccfecc align=center>
<td colspan=12><font size=1>A &nbsp; M</font></td>
<td colspan=12><font size=1>P &nbsp; M</font></td>
</tr></table>

HOURLYFOOTER

  }

  if( $stad ne $endd ) {
    if ( !$query->param('shw') ) {
      print <<WEEKLYHEADER;
<br><br>
    <table width=70%>
<tr bgcolor=#ccfecc align=center><td colspan=7><font size=1>D &nbsp; A &nbsp; Y &nbsp; &nbsp; &nbsp; O &nbsp; F &nbsp; &nbsp; &nbsp; T &nbsp; H &nbsp; E &nbsp; &nbsp; &nbsp; W &nbsp; E &nbsp; E &nbsp; K</font></td></tr>
<tr valign=bottom>
WEEKLYHEADER

      $max = $dayweek[0];
      for ($i=1; $i<7; $i++) {
        if( $max < $dayweek[$i] ) { $max = $dayweek[$i]; }  
      } 

      for ($i=0; $i<7; $i++) {
        use integer;
        $pct = $dayweek[$i] * 100;
        if($max>0) {
          $pct /= $max;
        }
        $pct -= 8;
        if( $pct < 2 ) { $pct = 2; }

        print <<WEEKLYBODY;
<td align=center><img width=10 height=4 src=gt.gif><br><img width=10 height=$pct src=gh.gif><br><img width=10 height=4 src=gb.gif></td>
WEEKLYBODY

        no integer;
      }

      print "<td align=center>";
      print "<img width=10 height=4 src=gt.gif><br><img width=10 height=2 src=gh.gif><br><img width=10 height=4 src=gb.gif><br>" x 10;

      print <<WEEKLYFOOTER;
</td>
</tr><tr bgcolor=#ccfecc align=center>
<td><font size=1>SUN</font></td><td><font size=1>MON</font></td><td><font size=1>TUE</font></td>
<td><font size=1>WED</font></td><td><font size=1>THU</font></td><td><font size=1>FRI</font></td>
<td><font size=1>SAT</font></td>
</tr></table>
WEEKLYFOOTER

    }
    if( !$query->param('shdm') ) {
      print <<DAILYHEADER;
<br><br>
<table width=70%>
<tr bgcolor=#ccfecc align=center>
<td colspan=31><font size=1>D &nbsp; A &nbsp; Y &nbsp; &nbsp; &nbsp; O &nbsp; F &nbsp; &nbsp; &nbsp; T &nbsp; H &nbsp; E &nbsp; &nbsp; &nbsp; M &nbsp; O &nbsp; N &nbsp; T &nbsp; H</font></td>
</tr>
<tr valign=bottom>
DAILYHEADER
 
      $max = $day[0];
      for( $i=1; $i<31; $i++ ) {
        if( $max < $day[$i] ) { $max = $day[$i]; }
      }
      for( $i=0; $i<31; $i++ ) {
        use integer;
        $pct = $day[$i] * 100;
        if ($max>0) {
          $pct /= $max;
        }
        $pct -= 8;
        if( $pct < 2 ) { $pct = 2; }

        print <<DAILYBODY;
<td align=center><img width=10 height=4 src=gt.gif><br><img width=10 height=$pct src=gh.gif><br><img width=10 height=4 src=gb.gif></td>
DAILYBODY

        no integer;
      }

      print "<td align=center>";
      print "<img width=10 height=4 src=gt.gif><br><img width=10 height=2 src=gh.gif><br><img width=10 height=4 src=gb.gif><br>" x 10;

      print <<DAILYMETER;
</td>
</tr>
<tr bgcolor=#ccfecc align=center>
DAILYMETER

      for( $i=1; $i<32; $i++ ) {   # {0+1} to {30+1} [0-30 = days 1-31]
        print "<td><font size=1>$i</font></td>"
      }
      print "</tr></table>";
    }
  } 

  if( !$query->param('shm') && (substr($l,0,6)!=substr($h,0,6)) ) {
    print <<MONTHLYHEADER;

<br><br>
<table width=70%>
<tr bgcolor=#ccfecc align=center><td colspan=12><font size=1>M &nbsp; O &nbsp; N &nbsp; T &nbsp; H &nbsp; L &nbsp; Y</font></td></tr>
<tr valign=bottom>

MONTHLYHEADER

    $max = $month[0];
    for ($i=1; $i<12; $i++) {
      if( $max < $month[$i] ) { $max = $month[$i]; }  
    }

    for ($i=0; $i<12; $i++) {
      use integer;
      $pct = $month[$i] * 100;
      if($max>0) {
        $pct /= $max;
      }
      $pct -= 8;
      if( $pct < 2 ) { $pct = 2; }

      print <<MONTHLYBODY;

<td align=center><img width=10 height=4 src=gt.gif><br><img width=10 height=$pct src=gh.gif><br><img width=10 height=4 src=gb.gif></td>

MONTHLYBODY

      no integer;
    }

    print "<td align=center>";
    print "<img width=10 height=4 src=gt.gif><br><img width=10 height=2 src=gh.gif><br><img width=10 height=4 src=gb.gif><br>" x 10;

    print <<MONTHLYFOOTER;

</td>
</tr><tr bgcolor=#ccfecc align=center>
<td><font size=1>JAN</font></td><td><font size=1>FEB</font></td><td><font size=1>MAR</font></td>
<td><font size=1>APR</font></td><td><font size=1>MAY</font></td><td><font size=1>JUN</font></td>
<td><font size=1>JUL</font></td><td><font size=1>AUG</font></td><td><font size=1>SEP</font></td>
<td><font size=1>OCT</font></td><td><font size=1>NOV</font></td><td><font size=1>DEC</font></td>
</tr></table>

MONTHLYFOOTER
  }
}

if ( $query->param('se') && $totfai ) {

  print "<br><br>$numfailedmachine machine";
  if( $numfailedmachine > 1 ) { print "s"; }
  print " generated $totfai error";
  if( $totfai > 1 ) { print "s"; }
  print ".<br>";

  if( !$query->param('stp') ) {
    print <<PAGEFAILUREHEADER;

<br><br>
<table>
<tr bgcolor=#ccfecc align=center>
<td colspan=4><font size=1>E &nbsp; R &nbsp; R &nbsp; O &nbsp; R &nbsp; S &nbsp; &nbsp; &nbsp; B &nbsp; Y &nbsp; &nbsp; &nbsp; P &nbsp; A &nbsp; G &nbsp; E</font></td>
</tr>

PAGEFAILUREHEADER

    printlist($mfbp, $totfai, \%failedbp, @sortedfailedbp);
    print "</TABLE>";
  }

  if( !$query->param('stm') ) {
    print <<HOSTFAILUREHEADER;
<br><br>
<table>
<tr bgcolor=#ccfecc align=center>
<td colspan=4><font size=1>E &nbsp; R &nbsp; R &nbsp; O &nbsp; R &nbsp; S &nbsp; &nbsp; &nbsp; B &nbsp; Y &nbsp; &nbsp; &nbsp; M &nbsp; A &nbsp; C &nbsp; H &nbsp; I &nbsp; N &nbsp; E</font></td>
</tr>
HOSTFAILUREHEADER
    printlist($mfbm, $totfai, \%failedbm, @sortedfailedbm);
    print "</TABLE>";
  }


  if( !$query->param('stt') ) { 
    print <<TOPFAILUREHEADER;
<br><br>
<table>
<tr bgcolor=#ccfecc align=center>
<td colspan=4><font size=1>E &nbsp; R &nbsp; R &nbsp; O &nbsp; R &nbsp; S &nbsp; &nbsp; &nbsp; B &nbsp; Y &nbsp; &nbsp; &nbsp; T &nbsp; O &nbsp; P &nbsp; - &nbsp; L &nbsp; E &nbsp; V &nbsp; E &nbsp; L &nbsp; &nbsp; &nbsp; D &nbsp; O &nbsp; M &nbsp; A &nbs

p; I &nbsp; N</font></td>
</tr>
TOPFAILUREHEADER

    printlist($mfbtl, $totfai, \%failedbtl, @sortedfailedbtl);

    print "</TABLE>";
  }
}

$query->param('options',1);
$url = $query->self_url;
postlink( 'OPTIONS' );
$query->delete('options');

printfooter();







